# icomesh

Fast JavaScript icosphere mesh generation library for WebGL visualizations. [Interactive demo](https://observablehq.com/@mourner/fast-icosphere-mesh):

<a href="https://observablehq.com/@mourner/fast-icosphere-mesh"><img alt="Icosphere mesh" src="https://user-images.githubusercontent.com/25395/65533055-a6561280-df05-11e9-89d5-37477274b4af.png"></a>

Icosphere is a type of [geodesic polyhedron](https://en.wikipedia.org/wiki/Geodesic_polyhedron) that provides a good quality triangular mesh approximation of a sphere with relatively evenly distributed vertices.
This code is based on [an article by Andreas Kahler](http://blog.andreaskahler.com/2009/06/creating-icosphere-mesh-in-code.html), with a few optimizations.

## Example

```js
import icomesh from 'icomesh';

// generate an icosphere with 4 subdivisions
const {vertices, triangles} = icomesh(4);
````

## API

### `icomesh(order = 4)`

Generates an icosphere mesh with `order` subdivisions (`4` by default, `10` max).
Returns an object with:

- `vertices`: A `Float32Array` array of `x, y, z` vertices.
- `triangles`: A `Uint16Array` or `Uint32Array` array of triangle indices.

You can reuse vertex data for normals because they are equal for a unit sphere.
